//+------------------------------------------------------------------+
//|                                                CNormalizacia.mqh |
//|                        Copyright 2015, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class CNormalizacia
  {
private:
   double            buf[];
   int               i,d1,d2,bars,bars2;
public:
   void              Normalizacia(int hendl,int lags,int bufer,int norma,int lag,datetime TimeStart,datetime TimeEnd,double &tmp[]);
   void              NormalizaciaNet(double x1,double x2,int norma,int lag,int lags,double &tmp[]);
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void  CNormalizacia::NormalizaciaNet(double x1,double x2,int norma,int lag,int lags,double &tmp[])
  {
   d1=-2;
   d2=2;
   double x_min=tmp[ArrayMinimum(tmp)];
   double x_max=tmp[ArrayMaximum(tmp)];
   for(i=0;i<ArraySize(tmp);i++)
     {
      if((x_max-x_min)!=0)
         tmp[i]=0.5*((((tmp[i]-x_min)*(d2-d1))/(x_max-x_min))+d1);
      else tmp[i]=0;
     }
     
   switch(norma)
     {
      case 1:
         ArrayResize(buf,ArraySize(tmp));
         ArrayCopy(buf,tmp);
         break;
      case 2:
         ArrayResize(buf,ArraySize(tmp));
         ArrayInitialize(buf,0);
         for(i=ArraySize(tmp)-2;i>=0;i--)
           {
            if(i<ArraySize(tmp)-1)buf[i]=buf[i+1];
            if(tmp[i]>x1&&tmp[i+1]<=x1)buf[i]=1;
            if(tmp[i]<x2&&tmp[i+1]>=x2)buf[i]=-1;
           }
         for(i=1;i<ArraySize(buf);i++)
           {
            if(buf[i]==0)buf[i]=buf[i-1];
           }

         break;
      case 3:
         ArrayResize(buf,ArraySize(tmp));
         ArrayInitialize(buf,0);
         for(i=ArraySize(tmp)-2;i>=0;i--)
           {
            buf[i]=buf[i+1];
            if(tmp[i]>tmp[i+1])buf[i]=1;
            if(tmp[i]<tmp[i+1])buf[i]=-1;
           }
         break;
     }

   if(lags>0)
      for(d2=1;d2<=lags;d2++)
         for(i=0;i<ArraySize(buf)-d2-1;i++)
           {
            for(d1=1;d1<=d2;d1++)
              {
               if(buf[i]>buf[i+d1] && buf[i+d2+1]>buf[i+d1])
                 {
                  if(d1==d2)
                    {
                     for(d1=i+1;d1<=i+d2;d1++)buf[d1]=(buf[i]+buf[i+d2+1])/2;
                     break;
                    }
                 }
               else
                 {
                  break;
                 }
              }
            for(d1=1;d1<=d2;d1++)
              {
               if(buf[i]<buf[i+d1] && buf[i+d2+1]<buf[i+d1])
                 {
                  if(d1==d2)
                    {
                     for(d1=i+1;d1<=i+d2;d1++)buf[d1]=(buf[i]+buf[i+d2+1])/2;
                     break;
                    }
                 }
               else
                 {
                  break;
                 }
              }
           }
   ArrayInitialize(tmp,0);
   for(i=0;i<ArraySize(buf);i++)
     {
      if(i+lag<0)continue;
      if(i+lag>ArraySize(buf)-1)continue;
      tmp[i]=buf[i+lag];
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CNormalizacia::Normalizacia(int hendl,int lags,int bufer,int norma,int lag,datetime TimeStart,datetime TimeEnd,double &tmp[])
  {

   ArrayResize(buf,2);
   bars2=CopyBuffer(hendl,bufer,TimeStart,TimeEnd,buf);
   if(bars2<0)return;
   CopyBuffer(hendl,bufer,(datetime)SeriesInfoInteger(_Symbol,_Period,SERIES_LASTBAR_DATE),Bars(_Symbol,_Period)-1,buf);
   double x_min=buf[ArrayMinimum(buf)];
   double x_max=buf[ArrayMaximum(buf)];
   ArrayResize(buf,2);

   if(lag>=0)
     {
      bars=CopyBuffer(hendl,bufer,TimeStart,(int)(bars2+MathAbs(lag)+1),buf);
      ArrayResize(buf,bars);
      ArrayResize(tmp,bars-1-MathAbs(lag));
     }
   if(lag<0)
     {
      bars=CopyBuffer(hendl,bufer,TimeStart+MathAbs(lag)*PeriodSeconds(),TimeEnd,buf);
      ArrayResize(buf,bars);
      if(TimeStart==SeriesInfoInteger(_Symbol,_Period,SERIES_LASTBAR_DATE))
        {
         ArrayResize(tmp,bars);
        }
      else
        {
         ArrayResize(tmp,bars-MathAbs(lag));
        }
     }
   switch(norma)
     {
      case 1:
         break;
      case 2:
         d1=0;
         d2=1;
         for(i=0;i<ArraySize(buf);i++)
           {
            if(buf[i])buf[i]=(((buf[i]-x_min)*(d2-d1))/(x_max-x_min))+d1;
           }
         break;
      case 3:
         d1=-2;
         d2=2;
         if(MathAbs(x_min)>x_max && x_min<0)
           {
            x_max=MathAbs(x_min);
           }
         else
           {
            if(x_min<0)
               x_min=x_max*-1;
           }
         for(i=0;i<ArraySize(buf);i++)
           {
            if((x_max-x_min)!=0)
               buf[i]=0.5*((((buf[i]-x_min)*(d2-d1))/(x_max-x_min))+d1);
            else buf[i]=0;
           }
         break;
      case 4:
         for(i=0;i<ArraySize(buf);i++)
           {
            //buf[i]=0;

            if(buf[i]>0){buf[i]=1;continue;}
            if(buf[i]<0){buf[i]=-1;continue;}
            if(i>0)buf[i]=buf[i-1];
           }
         break;
      case 5:
         for(i=ArraySize(buf)-1;i>0;i--)
           {
            if(buf[i]<buf[i-1]){buf[i]=-1;continue;}
            if(buf[i]>buf[i-1]){buf[i]=1;continue;}
            buf[i]=0;
           }
         break;
      case 6:
         for(i=0;i<ArraySize(buf);i++)
           {
            if(buf[i]>0){buf[i]=1;continue;}
            if(buf[i]<0){buf[i]=-1;continue;}
            buf[i]=0;
           }
         bars=0;bars2=0;
         for(d2=0;d2<=lags;d2++)
           {
            for(i=ArraySize(buf)-1;i>0;i--)
              {
               if(buf[i]<0)
                 {
                  bars++;
                  if(i>0)
                     if(buf[i-1]<0)
                       {
                        continue;
                       }
                  for(d1=i;d1<ArraySize(buf);d1++)if(buf[d1]<0)bars2++;else break;
                  if(bars2>bars)bars=0;
                  bars2=0;
                 }
               if(buf[i]>0)
                 {
                  bars++;
                  if(i>0)
                     if(buf[i-1]>0)
                       {
                        continue;
                       }
                  for(d1=i;d1<ArraySize(buf);d1++)if(buf[d1]>0)bars2++;else break;
                  if(bars2>bars)bars=0;
                  bars2=0;
                 }
               if(bars<=d2)
                 {
                  if(i+bars<ArraySize(buf))
                  for(d1=i;d1<i+bars;d1++){buf[d1]=buf[d1]*-1;}
                  bars=0;
                 }
               bars=0;
              }
           }
         break;
      case 7:
         for(i=ArraySize(buf)-1;i>0;i--)
           {
            if(buf[i]<buf[i-1]){buf[i]=-1;continue;}
            if(buf[i]>buf[i-1]){buf[i]=1;continue;}
            buf[i]=0;

           }

         bars=0;bars2=0;
         for(d2=0;d2<=lags;d2++)
           {
            for(i=ArraySize(buf)-1;i>0;i--)
              {
               if(buf[i]<0)
                 {
                  bars++;
                  if(i>0)
                     if(buf[i-1]<0)
                       {
                        continue;
                       }
                  for(d1=i;d1<ArraySize(buf);d1++)if(buf[d1]<0)bars2++;else break;
                  if(bars2>bars)bars=0;
                  bars2=0;
                 }
               if(buf[i]>0)
                 {
                  bars++;
                  if(i>0)
                     if(buf[i-1]>0)
                       {
                        continue;
                       }
                  for(d1=i;d1<ArraySize(buf);d1++)if(buf[d1]>0)bars2++;else break;
                  if(bars2>bars)bars=0;
                  bars2=0;
                 }
               if(bars<=d2)
                 {
                  if(i+bars<ArraySize(buf))
                  for(d1=i;d1<i+bars;d1++){buf[d1]=buf[d1]*-1;}
                  bars=0;
                 }
               bars=0;
              }
           }
         break;
      case 8:
         for(i=0;i<ArraySize(buf);i++)
           {
            if(buf[i]>50){buf[i]=1;continue;}
            if(buf[i]<50){buf[i]=-1;continue;}
            buf[i]=0;
           }
         break;
     }

   ArrayInitialize(tmp,0);
   if(lag>=0)
     {

      for(i=ArraySize(tmp)-1;i>=0;i--)
        {
         tmp[i]=buf[i+1];
        }
     }
   if(lag<0)
      for(i=ArraySize(tmp)-1;i>=0;i--)
        {
         if(TimeStart==SeriesInfoInteger(_Symbol,_Period,SERIES_LASTBAR_DATE))
           {
            if(i+MathAbs(lag)>=ArraySize(buf))continue;
            tmp[i]=buf[i+MathAbs(lag)];
           }
         else
           {
            tmp[i]=buf[i+MathAbs(lag)];
           }
        }
  }
//+------------------------------------------------------------------+
