//+------------------------------------------------------------------+
//|                                                      CZigZag.mqh |
//|                        Copyright 2015, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#include "S_index_param.mqh"
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class CZigZag
  {
private:
   double            Close[];
   double            High[];
   double            Low[];
   double            zzH[];
   double            zzL[];
   double            buf[];
   double            buf2[];
   datetime          dat[];
   double            curlow,lasthigh,lastlow;
   double            min,max;
   double            curhigh1;
   int               i,fg,k;
   int               bar,br,shift,shiftH,shiftL,pos,lasthighpos,lastlowpos,curhighpos,curlowpos;

public:
   void              CZigZag();
   void             ~CZigZag();
   datetime          time_start;
   datetime          time_end;
   void              ZigZag(S_index_param &index_param);
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
CZigZag::CZigZag()
  {
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
CZigZag::~CZigZag()
  {
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CZigZag::ZigZag(S_index_param &index_param)
  {
   shiftH=0;shiftL=0;

   fg=index_param.ZZ_ind_lag*-1;

   bar=CopyTime(_Symbol,_Period,
                (datetime)SeriesInfoInteger(_Symbol,_Period,SERIES_LASTBAR_DATE),//   
                index_param.time_trener,//   
                dat     //     
                );
   CopyClose(_Symbol,_Period,0,bar+MathAbs(fg)+100,Close);
   CopyHigh(_Symbol,_Period,0,bar+MathAbs(fg)+100,High);
   CopyLow(_Symbol,_Period,0,bar+MathAbs(fg)+100,Low);
   ArraySetAsSeries(Close,true);
   ArraySetAsSeries(High,true);
   ArraySetAsSeries(Low,true);
   k=ArraySize(Close);
   ArrayResize(zzH,k);
   ArrayResize(zzL,k);
   ArrayResize(buf,k);
   ArrayResize(buf2,bar);
   ArrayResize(index_param.tmp,bar);
   ArrayInitialize(zzL,0.0);
   ArrayInitialize(zzH,0.0);
   ArrayInitialize(buf,0.0);
   ArrayInitialize(buf2,0.0);
   shift=k-index_param.ZZ_ind_period;
   lasthighpos=0; lastlowpos=0;
   lastlow=Close[0];lasthigh=Close[0];
   for(int t=0;t<=shift;t++)
     {
      if(index_param.ZZ_ind_prise==1)
        {
         curlowpos=ArrayMinimum(Close,t-shiftL,index_param.ZZ_ind_period+shiftL);
         curlow=Close[curlowpos];
         curhighpos=ArrayMaximum(Close,t-shiftH,index_param.ZZ_ind_period+shiftH);
         curhigh1=Close[curhighpos];
        }
      if(index_param.ZZ_ind_prise==2)
        {
         curlowpos=ArrayMinimum(Low,t-shiftL,index_param.ZZ_ind_period+shiftL);
         curlow=Low[curlowpos];
         curhighpos=ArrayMaximum(High,t-shiftH,index_param.ZZ_ind_period+shiftH);
         curhigh1=High[curhighpos];
        }
      //--- high
      if(curhigh1<=lasthigh) { lasthigh=curhigh1;}
      else
        {
         //   
         if(lastlowpos<curhighpos)
           {
            if(lastlowpos<curhighpos-index_param.ZZ_ind_min_bar && curhigh1-zzL[lastlowpos]>index_param.ZZ_ind_min_point*Point())
              {

               zzH[curhighpos]=curhigh1;
               //           
               max=-100000; pos=lastlowpos;
               for(i=lastlowpos; i<=curhighpos; i++)
                 {
                  if(zzH[i]<=0.0) continue;
                  if(zzH[i]>max) { max=zzH[i]; pos=i; }
                  if(i>=0) buf[i]=0.0;
                 }
               // Print(zzH[i]);
               if(i>0)
                 {
                  buf[pos]=-1;
                 }
               else
                 {
                  buf[0]=-0;
                 }
               lasthighpos=pos;
               shiftH=0;
               shiftL=0;
              }
           }
         lasthigh=curhigh1;
        }
      //------------------------------------------------
      //--- low
      if(curlow>=lastlow){ lastlow=curlow; }
      else
        {
         // 
         if(lasthighpos<curlowpos)
           {
            if(lasthighpos<curlowpos-index_param.ZZ_ind_min_bar && zzH[lasthighpos]-curlow>index_param.ZZ_ind_min_point*Point())
              {
               zzL[curlowpos]=curlow;
               //         
               min=100000; pos=lasthighpos;
               for(i=lasthighpos; i<=curlowpos; i++)
                 {
                  if(zzL[i]==0.0) continue;
                  if(zzL[i]<min) { min=zzL[i]; pos=i; }
                  if(i>=0)buf[i]=0.0;
                 }
               if(i>0)
                 {
                  buf[pos]=1;
                 }
               else
                 {
                  buf[0]=0;
                 }
               lastlowpos=pos;
               shiftH=0;
               shiftL=0;
              }
            //----
           }
         lastlow=curlow;
        }
     }
   if(index_param.ZZ_ind_pnull_last)
     {
      for(i=ArraySize(buf)-2;i>=0;i--)
        {
         if(buf[i]==0 && buf[i]<ArraySize(buf)-1)buf[i]=buf[i+1];

        }
     }
   for(i=0;i<ArraySize(buf2);i++)
     {
      if(i-fg>=0)(buf2[i]=buf[i-fg]);
     }
   ArrayCopy(index_param.tmp,buf2);
  }

//+------------------------------------------------------------------+
